import { world } from "@minecraft/server"
import { hasEquipmentArtifact, randomInt } from '../utils/functions.js'



world.afterEvents.entityHurt.subscribe(ev => {
    let damager = ev.damageSource.damagingEntity
    let hurtEntity = ev.hurtEntity

    try {
        if (hurtEntity.typeId != 'minecraft:player') { return }

        let feetEquipment = hurtEntity.getComponent("equippable")?.getEquipment('Feet')
        if (hasEquipmentArtifact(hurtEntity, feetEquipment, 'artifacts:steadfast_spikes')) {
            //world.sendMessage('uh')
            let view = damager?.getViewDirection()
            hurtEntity.applyKnockback({ x: -view.x * 0.4, z: -view.z * 0.4 }, -0.2)
        }
    } catch { }
})
