import { world, ItemStack, system } from "@minecraft/server"
import { hasEquipmentSlot, randomInt } from "./utils/functions";

import './lore.js'
import './mobEquipment.js'
import './entities/mimic.js'
import './entities/playerSpawn.js'

//Necklace
import './items/panic_necklace.js'
import './items/shock_pendant.js'
import './items/cross_necklace.js'
import './items/flame_pendant.js'
import './items/thorn_pendant.js'
import './items/lucky_scarf.js'

//Hands
import './items/fire_gauntlet.js'
import './items/golden_hook.js'
import './items/pocket_piston.js'
import './items/feral_claws.js'
import './items/onion_ring.js'
import './items/power_glove.js'
import './items/pickaxe_heater.js'
import './items/withered_bracelet.js'
import './items/steadfast_spikes.js'

//Belt
import './items/obsidian_skull.js'
import './items/cloud_in_a_bottle.js'
import './items/universal_attractor.js'
import './items/antidote_vessel.js'
import './items/chorus_totem.js'
import './items/warp_drive.js'


//Head
import './items/superstitious_hat.js'
import './items/anglers_hat.js'
import './items/whoopee_cushion.js'



//Miscelaneous
import './items/loop_artifacts_slots.js'
import './items/eternal_steak.js'

import './items/boots.js'



/*
world.afterEvents.itemUse.subscribe(ev => {
    let item = ev.itemStack

    let source = ev.source

    if (item.typeId == 'minecraft:clock') {
        let lore = item.getLore()
        world.sendMessage(`${JSON.stringify(lore)}`)
    }

}) */


/* function vectorDistance(v1, v2) {
    const dx = v2.x - v1.x;
    const dy = v2.y - v1.y;
    const dz = v2.z - v1.z;
    return Math.sqrt(dx * dx + dy * dy + dz * dz);
}

system.runInterval(() => {
    const players = world.getAllPlayers()
    players.forEach(player => {

        const { x, y, z } = player.location
        const dimension = player.dimension

        const block = dimension.getBlock({ x: x, y: y - 1, z: z })
        //if (block.typeId == 'minecraft:water')
        let previousEntity = dimension.getEntitiesAtBlockLocation(block.center())[0]

        if (block.typeId != 'minecraft:water' && !block.isWaterlogged) {
            return
        }

        if (previousEntity || player.isSneaking || player.isInWater) { return }

        const entity = dimension.spawnEntity('artifacts:dummy_platform', { x: block.center().x, y: block.center().y - 0.1, z: block.center().z })
        const tameableComponent = entity.getComponent('tameable')
        tameableComponent.tame(player)
    })
}, 1)
world.afterEvents.dataDrivenEntityTrigger.subscribe(ev => {
    const { entity, eventId } = ev
    if (entity.typeId == 'artifacts:dummy_platform' && eventId == 'artifacts:try_despawn') {
        const tameableComponent = entity.getComponent('tameable')
        let owner = tameableComponent.tamedToPlayer
        const distance = vectorDistance(entity.location, owner.location)
        world.sendMessage(`La distancia hasta el owner es de: ${distance.toString()}`)
        if (!owner || distance > 1.5 || owner.isSneaking) {
            entity.remove()
        }
    }
})
 */

