import { world } from "@minecraft/server"
import { hasEquipmentArtifact, randomInt } from '../utils/functions.js'

import { FishingEvent, FishingResult } from '../utils/FishingEvent.js';

FishingEvent.playerReleaseFishing.subscribe((data) => {
    const { player, beforeItemStack, attachedToEntity } = data;
    const { result, fishedItems, location, duration } = data.fishingInfo;

    let headEquipment = player.getComponent('equippable').getEquipment('Head')
    if (hasEquipmentArtifact(player, headEquipment, 'artifacts:anglers_hat')) {
        fishedItems.forEach(fishedItem => {
            //world.sendMessage(`${fishedItem.typeId}`)
            //33% por cada item dropeado de duplicarlo
            if (randomInt(1, 3) == 1) {
                //world.sendMessage('loot')
                player.dimension.spawnItem(fishedItem, player.location)
            }
        })
    }

});