import { world } from "@minecraft/server"
import { hasEquipmentArtifact } from '../utils/functions.js'

//gracias por todo cib :p
world.afterEvents.entityHurt.subscribe((arg) => {
    const { hurtEntity, damage, damageSource } = arg;
    if (hurtEntity.typeId != 'minecraft:player') { return }
    if (damage > 0 || damageSource.cause !== "none") {
        return;
    }
    let legsEquipment = hurtEntity.getComponent('equippable').getEquipment('Legs')

    //world.sendMessage('totem consumido')
    if (hasEquipmentArtifact(hurtEntity, legsEquipment, 'artifacts:chorus_totem')) {
        //world.sendMessage('debug')
        hurtEntity.runCommand('spreadplayers ~ ~ 5 30 @s')

    }
});