import { world } from "@minecraft/server"
import { randomInt, hasEquipmentArtifact } from '../utils/functions.js'


world.afterEvents.entityHurt.subscribe(ev => {
    const damager = ev.damageSource.damagingEntity
    const hurtEntity = ev.hurtEntity


    try {
        if (damager.typeId != 'minecraft:player') { return }

        let chestEquipment = damager.getComponent('equippable').getEquipment('Chest')

        if (hasEquipmentArtifact(damager, chestEquipment, 'artifacts:feral_claws')) {
            const randomDamage = randomInt(1, 3);
            //hurtEntity.applyDamage(damage);
            const healthComp = hurtEntity.getComponent('health')
            healthComp.setCurrentValue(healthComp.currentValue - randomDamage)
        }

    } catch { }

})