import { world } from "@minecraft/server"
import { randomInt, hasEquipmentArtifact } from '../utils/functions.js'



world.afterEvents.entityHurt.subscribe(ev => {
    const damager = ev.damageSource.damagingEntity
    const hurtEntity = ev.hurtEntity


    try {
        if (hurtEntity.typeId != 'minecraft:player') { return }

        let chestEquipment = hurtEntity.getComponent('equippable').getEquipment('Chest')

        if (hasEquipmentArtifact(hurtEntity, chestEquipment, 'artifacts:flame_pendant') && randomInt(1, 100) <= 40) {
            damager.setOnFire(10)
        }

    } catch { }

})