import { world, ItemStack, InputPermissionCategory } from "@minecraft/server"
import { hasEquipmentArtifact } from '../utils/functions.js'



//Podrias mejorar esto simplemente quitandole el raw y luego añadiendole ingot al typeID
const oreMap = {
    "minecraft:raw_iron": "minecraft:iron_ingot",
    "minecraft:raw_copper": "minecraft:copper_ingot",
    "minecraft:raw_gold": "minecraft:gold_ingot",
}

world.beforeEvents.playerBreakBlock.subscribe(async ev => {
    let block = ev.block
    let player = ev.player
    let item = ev.itemStack

    //player.inputPermissions.setPermissionCategory(InputPermissionCategory.Dismount, false)

    let chestEquipment = player.getComponent('equippable').getEquipment('Chest')

    //world.sendMessage(block.typeId)
    if (hasEquipmentArtifact(player, chestEquipment, 'artifacts:pickaxe_heater') && block.typeId.includes('ore') && item.typeId.includes('pickaxe')) {
        await null;
        let blockLocation = block.location
        let oreEntities = block.dimension.getEntities({ type: "minecraft:item", maxDistance: 2, location: block.location })

        oreEntities.forEach(oreEntity => {
            let oreItem = oreEntity?.getComponent('item').itemStack

            if (!oreMap[oreItem.typeId]) {
                return
            }
            oreEntity.remove()
            let moltenOre = new ItemStack(oreMap[oreItem.typeId])
            player.dimension.spawnItem(moltenOre, blockLocation)
            //world.sendMessage(blockId)
        })



    }
})