import { world, system } from "@minecraft/server"
import { hasEquipmentArtifact } from '../utils/functions.js'


world.afterEvents.entityHurt.subscribe(ev => {
    const damager = ev.damageSource.damagingEntity
    const hurtEntity = ev.hurtEntity

    //world.sendMessage(`${damager?.typeId}`)
    if (damager?.typeId != 'minecraft:player') { return }

    let chestEquipment = damager.getComponent('equippable').getEquipment('Chest')

    if (hasEquipmentArtifact(damager, chestEquipment, 'artifacts:power_glove')) {
        const healthComp = hurtEntity.getComponent('health')
        healthComp.setCurrentValue(healthComp.currentValue - 4)
        //hurtEntity.applyDamage(4);
    }

})